define(['jquery', 'bootstrap', 'backend', 'table', 'form', 'jstree'], function ($, undefined, Backend, Table, Form, undefined) {
    //读取选中的条目
    $.jstree.core.prototype.get_all_checked = function (full) {
        var obj = this.get_selected(), i, j;
        for (i = 0, j = obj.length; i < j; i++) {
            obj = obj.concat(this.get_node(obj[i]).parents);
        }
        obj = $.grep(obj, function (v, i, a) {
            return v != '#';
        });
        obj = obj.filter(function (itm, i, a) {
            return i == a.indexOf(itm);
        });
        return full ? $.map(obj, $.proxy(function (i) {
            return this.get_node(i);
        }, this)) : obj;
    };
    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'user/group/index',
                    edit_url: 'user/group/edit',
                    table: 'user_group',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'mobile', title: __('Mobile')},
                        {field: 'invitation_code', title: __('Invitation_code')},
                        {field: 'agent_in_usdt', title: __('Agent_in_usdt'), searchList: {0: __('Close'), 1: __('Open')} , formatter: Table.api.formatter.status},
                        {field: 'agent_in_bank', title: __('Agent_in_bank'), searchList: {0: __('Close'), 1: __('Open')}, formatter: Table.api.formatter.status},
                        {field: 'agent_out_usdt', title: __('Agent_out_usdt'), searchList: {0: __('Close'), 1: __('Open')}, formatter: Table.api.formatter.status},
                        {field: 'agent_out_bank', title: __('Agent_out_bank'), searchList: {0: __('Close'), 1: __('Open')}, formatter: Table.api.formatter.status},
                        {field: 'service_link', title: __('Service_link')},
                        {field: 'team_num', title: __('Team')},
                        {field: 'operate', title: __('Operate'), table: table,
                            buttons: [{
                                name: "edit",
                                text:  __('Edit'),
                                classname: 'btn btn-xs btn-success btn-magic btn-dialog',
                                url: 'user/group/edit',
                                refresh: true
                            },{
                                name: "disable",
                                text:  __('Disable'),
                                classname: 'btn btn-xs btn-danger btn-magic btn-ajax',
                                confirm: __('Confirm review'),
                                url: 'user/group/disable/is_lock/1',
                                visible: function (row) {
                                    if(row.is_lock == 0)  return true;
                                    return false;
                                },
                                refresh: true
                            }],
                            events: Table.api.events.operate, formatter: Table.api.formatter.operate
                        }
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },

        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"), null, null, function () {
                    if ($("#treeview").length > 0) {
                        var r = $("#treeview").jstree("get_all_checked");
                        $("input[name='row[rules]']").val(r.join(','));
                    }
                    return true;
                });
                //渲染权限节点树
                //销毁已有的节点树
                $("#treeview").jstree("destroy");
                Controller.api.rendertree(nodeData);
                //全选和展开
                $(document).on("click", "#checkall", function () {
                    $("#treeview").jstree($(this).prop("checked") ? "check_all" : "uncheck_all");
                });
                $(document).on("click", "#expandall", function () {
                    $("#treeview").jstree($(this).prop("checked") ? "open_all" : "close_all");
                });
                $("select[name='row[pid]']").trigger("change");
            },
            rendertree: function (content) {
                $("#treeview")
                        .on('redraw.jstree', function (e) {
                            $(".layer-footer").attr("domrefresh", Math.random());
                        })
                        .jstree({
                            "themes": {"stripes": true},
                            "checkbox": {
                                "keep_selected_style": false,
                            },
                            "types": {
                                "root": {
                                    "icon": "fa fa-folder-open",
                                },
                                "menu": {
                                    "icon": "fa fa-folder-open",
                                },
                                "file": {
                                    "icon": "fa fa-file-o",
                                }
                            },
                            "plugins": ["checkbox", "types"],
                            "core": {
                                'check_callback': true,
                                "data": content
                            }
                        });
            }
        }
    };
    return Controller;
});
